/*************************************************
* CRC32 Header File                              *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#ifndef OPENCL_CRC32_H__
#define OPENCL_CRC32_H__

#include <opencl/opencl.h>

namespace OpenCL {

/*************************************************
* CRC32                                          *
*************************************************/
class CRC32 : public HashFunction
   {
   public:
      static const u32bit HASHLENGTH = 4;

      void clear() throw() { crc = 0xFFFFFFFF; }
      std::string name() const { return "CRC32"; }
      HashFunction* clone() const { return new CRC32; }
      CRC32() : HashFunction(4) { clear(); }
      ~CRC32() { clear(); }
   private:
      void add_data(const byte[], u32bit);
      void final_result(byte[]);
      static const u32bit TABLE[256];
      u32bit crc;
   };

}

#endif
